// pgp4pine prefs.c

// See common.c for the version and license.
// Copyright (C) 1998 by Chris Wiegand

#include "includes.h"

// -------------------------------------------------------------------------

char *readPrefs(const char *searchKey, char *defaultVal)
{
	// searchKey is "text", and defaultVal is "text" too
	// so they're safe pointers...
	FILE *prefsFile;
	char inLine[PREFS_LINE_LENGTH];
	char *key;
	char *value;
	char *homeDir;
	char prefsFileName[MAX_COMMAND_LINE_LENGTH];

	key = myMalloc(PREFS_LINE_LENGTH);
	value = myMalloc(PREFS_LINE_LENGTH);
	homeDir = myMalloc(MAX_COMMAND_LINE_LENGTH);
	
	// Okay, first, let's get the rc file name ($HOME/.pgp4pinerc)	
	homeDir = getenv("HOME");
	if (!homeDir || !*homeDir) homeDir = "/tmp";
	strcpy(prefsFileName,homeDir);
	strcat(prefsFileName,"/.pgp4pinerc");
	
	// now, open it...
	if ((prefsFile = fopen(prefsFileName,"r"))!=NULL) {
		while (!feof(prefsFile)) {
			// get a line, parse it for variable and value, then compare against
			// what we want.
			fgets(inLine,PREFS_LINE_LENGTH,prefsFile);
			// sprintf(debugLine,"readPrefs: lineIn: -%s-",inLine); 
			// documentStatus(debugLine);
			if (strncmp("#",inLine,1) != 0 && strncmp("//",inLine,2) != 0 ) {
				// comments always start with # in rc files
				key = strtok(inLine,"= ");
				value = strtok('\0',"= \n");
				if (strcmp(key,searchKey) == 0) {
					fclose(prefsFile);
					return value;
				}
			}
		}
		fclose(prefsFile);
	}
	sprintf(debugLine,"readPrefs: variable NOT found: -%s-\n",searchKey); 
	documentStatus(debugLine);
	myFree(key);
	myFree(value);
	myFree(homeDir);
	return defaultVal;
}

void readRCFile()
{
	prefsOverrideRecipients = atoi(readPrefs("override_recipients","0"));
	strcpy(prefsMyPager,readPrefs("external_pager","more"));
	prefsVerboseOutput = atoi(readPrefs("verbose_output","1"));
}

